var initpage;
var sbqDate = ''
$(function () {
    // 如果生产环境上，传递djxh，则视为无效
    if(config.environmental=="production" && getUrlParam("djxh")){
        window.open(config.webUrl + "error/newError.html",'_self')
    }
  showLoading();
  getInitTable();
})

function getInitTable() {
  $.ajax({
    type: "post",
    url: config.url + "/ssfwpt/declare/index",
    dataType: "json", // 请求方式为jsonp
    // async: false,
    data: {
      djxh: getUrlParam("djxh"),
      token: getUrlParam("token"),
      sbsq: "",
      pzzlDm: getUrlParam("pzzlDm"),
    },
    // beforeSend:function(){
    //   myAlert("提示", "正在获取初始化信息", "确定")
    // },
    success: function (data) { //客户端jquery预先定义好的callback函数，成功获取跨域服务器上的json数据后，会动态执行这个callback函数
      hideLoading();
      //el表达式变jqa
      // $("#token").attr("value","");
      if (data.success) {
        if (data.bean.url == "error.jsp") {
          myAlert("提示", data.bean.errorInfo, "确定")
          // window.location.href = "/jsp/error/index.html?falg="+param;
          return
        }
      }

      var companyInfo = data;
      if (companyInfo.success) {
        config.value = companyInfo.bean.value
        companyInfo.bean.config = config
        companyInfo.bean.return = true; /* @Author ygy @Date 10:12 2020/7/8 @Description 前端判断接口成功返回数据标记用于区分是否执行初始化table方法*/
        config.return = true;
        initpage = initPage(companyInfo.bean);
      } else {
        hideLoading();
        if (!companyInfo.bean) {
          companyInfo.bean = {};
          companyInfo.bean.djxh = getUrlParam("djxh");
          companyInfo.bean.return = false;
        }
        alertWarning(companyInfo.errmsg);
        companyInfo.bean.config = config
        initpage = initPage(companyInfo.bean);
        // 弹出错误对话框
      }
      $("#getInputValue").on("focus", function () {
        WdatePicker({
          isShowClear: false,
          dateFmt: 'yyyy-MM',
          onpicking: function (dp) {

            initpage.changeDate(this, dp);
          }
        });
      });
    },
    error: function (xhr) {
      hideLoading();
      //jsonp 方式此方法不被触发
      console.log("=======error======================")
    }
  })
}
/**
 * 按期申报填报列表页控制脚本
 *
 * @author 于广洋
 * @modify 王雷
 */
// -------------------------------
/**
 * 绘制税种填报页面
 *
 * @param {*} companyInfo
 */
function initPage(companyInfo) {
  getIEVersion();
  localStorage.setItem("cancellation", null);
  var companyInfo = companyInfo;
  var djxh = companyInfo.djxh;
  var nowdate = ""; // 存储当前选择的时间框;
  var submitData
  /**
   * 展示税种申报信息
   */
  var showTax = function (taxInfo) {
    //        console.log(taxInfo,companyInfo);
    if (taxInfo.length > 0) {
      for (var i = 0; i < taxInfo.length; i++) {
        if (taxInfo[i].sbrq) {
          taxInfo[i].sbrq = tool.formatDate(taxInfo[i].sbrq.split(" ")[0]);
        }
      }
    }
    var id = "#taxGrid";
    var buttonHtml = "填写申报表";
    var order = ["pzzlMc", "sssqQ", "sssqZ", "sbrq", "do"];
    var promptStatement = "";
    var headerList = [{
      name: "序号",
      width: "5%"
    }, {
      name: "申报表",
      width: "55%"
    }, {
      name: "税款所属期起",
      width: "10%"
    }, {
      name: "税款所属期止",
      width: "10%"
    }, {
      name: "申报日期",
      width: "10%"
    }, {
      name: "操作",
      width: "10%"
    }];
    console.log(taxInfo);
    //渲染表
    getTableDeclaration(id, order, headerList, taxInfo, buttonHtml, promptStatement)
  };
  /**
   * 税务申报table渲染
   * @param {*} id
   * @param {*} order
   * @param {*} headerList
   * @param {*} ddt
   * @param {*} buttonHtml
   */
  var getTableDeclaration = function (id, order, headerList, ddt, buttonHtml, promptStatement) {
    var tableObj = {
      id: id, //tabel父元素的id
      autoHeight: ddt.length > 0 ? 10 : "",
      containerWidth: "99%", //table占父元素的百分比
      autoHeight: ddt.length > 0 ? 10 : "", // 默认10行
      order: order, //数据按照什么顺序排序  1.do为是否保函操作 2.序号列会自动添加不需要写
      onlyId: "uuId", //数据的唯一标识
      height: "320", //表格的高度
      buttonHeight: "", //表格的高度
      buttonHtml: buttonHtml, //按钮里的字
      headerList: headerList, //表头名字及占比，顺序与order对应
      promptStatement: promptStatement, // 没有数据时默认提示
      data: {
        page: "1",
        pageSize: ddt.length
      },
      jsonReady: ddt,
      callback: function (data, node) {
        console.log(data);
        if (data.sbzt == "Y") {
          myAlert("提示", "当前申报表已经申报", "确定")
          return false;
        }
        if (data.sourceFlag == "ssfwpt_sbzj") {
          window.mlistener = {
            selectRowData: {},
          };
          data.fillingFlag = "normal" // 填报标记
          data.saveUserId = "zxtb"; // 用户id
          data.value = config.value;
          window.mlistener.selectRowData = data;
          window.open(config.ssfwptPage, '_blank');
          Object.defineProperty(mlistener, 'returnSelectRowData', {
            set: function (val) {
              getTaxDeclaration(sbqDate, "Y");
            }
          })
        } else {
          data.djxh = companyInfo.djxh;
          data.iszzsybjc = companyInfo.iszzsybjc; // 一表申报代码
          data.nsrsbh = companyInfo.nsrsbh; // 那随人识别号
          data.nssbq = nowdate;
          data.checkTime = false;
          if (data.pzzlDm === '11602') {
            var List = companyInfo.taxInfos.filter(function (item) {
              return item.pzzlDm == '10101' || item.pzzlDm == '10102'
            })
            if (List.length === 0) {
              data.checkTime = true;
            }
            for (var i = 0; i < List.length; i++) {
              if (List[i].sssqQ !== data.sssqQ || List[i].sssqZ !== data.sssqZ) {
                data.checkTime = true;
                break;
              }
            }
          }
          submitData = data;
          if (node.context.innerText == "填写申报表" && companyInfo.iszzsybjc == "01" && data.pzzlDm == "10101") {
            // if(node.context.innerText=="填写申报表"){
            console.log(initpage)
            initpage.declarationMethod('N')
            //                    $('#myMask').show();
            //                    $('#myModal').show();
            //                    $('#dName').html(data.pzzlMc);
            //                    $('#dName').attr("title",data.pzzlMc);//修改title值
            //                    $('#ybName').html(data.pzzlMc);
            //                    $('#ybName').attr("title",data.pzzlMc);//修改title值
          } else {
            declarationMethod("N")
          }
        }
      } //点击按钮后的回调函数
    };
    var object = tool.tableCreate(tableObj);
    //        object.jsonReadyTo(ddt, { page: "1", pageSize: ddt.length });
  };

  /**
   * 税务申报 初始化数据获取
   * @param {*} mydate
   */
  //地址
  //http://sbjs.tjsat.gov.cn:18090
  //http://localhost:7070
  var url;
  if (companyInfo) {
    url = companyInfo.config.url;
  }
  var getTaxDeclaration = function (date, type) {
    // TODO 开始加载等待动画
    showLoading();
    var param = {
      djxh: djxh,
      operateType: companyInfo.operateType,
      sbsq: date,
      isFresh: type.toUpperCase() == "Y",
      pzzlDm: companyInfo.pzzlDm
    }
    $.ajax({
      url: url + "/ssfwpt/declare/getPzzlList",
      data: param,
      type: "POST",
      dataType: "JSON",
      // beforeSend:function(){
      //   myAlert("提示", "正在获取初始化信息", "确定")
      // },
    }).done(function (data) {
      console.log(data)
      if (data.success) {
        if (data.bean.url == "error.jsp") {
          myAlert("提示", data.bean.errorInfo, "确定")
          return
        }
        drawGrid(data.bean);
        companyInfo = data.bean;
      } else {
        alertWarning(data.errmsg);
      }
    }).always(function (data) {
      hideLoading();
    });
  };
  /**
   * 隐藏modal
   */
  var closeModal = function () {
    $('#ybName').html("");
    $('#dName').html("");
    $('#myMask').hide();
    $('#myModal').hide();
  }

  var drawGrid = function (bean) {
    //两个表合成一个表
    $.each(bean.financialInfos, function (i, item) {
      bean.taxInfos.push(item);
    });
    console.log(bean)
    if (bean.taxInfos.length == 0) {
      showTax(bean.taxInfos);
      alertInfo("税费申报暂无数据");
    } else {
      showTax(bean.taxInfos);
    }
  };

  /**
   * 日期改变时触发
   * N 非强制刷新
   * @param {*} obj
   * @param {*} dp
   */
  var changeDate = function (obj, dp) {
    date = dp.cal.getNewDateStr();
    nowdate = date; // 给缓存时间赋值
    // 加了一个延时，时间改变后时间框没有收起隐藏就加载数据，没有找到好的解决办法，暂时用延时处理
    sbqDate = date
    setTimeout(function () {
      getTaxDeclaration(date, "N");
    }, 50);
  };

  var refresh = function () {
    myConfirm("消息", "您确定需要重置申报清册吗？点击确定继续", "确定", "取消", function () {
      getTaxDeclaration(nowdate, "Y");
    });
  };
  //申报方式 当iszzsybjc=01同时pzzlDm=010101时，调用改方法
  var declarationMethod = function (statu) {
    submitData.ybjcState = statu;
    console.log(submitData.sourceFlag, submitData.sourceFlag.indexOf("sbzj") != -1)
    //需要判断在线还是税表的开关
    if (submitData.sourceFlag == "ssfwpt_sbzj") {
      window.mlistener = {
        selectRowData: {},
      };
      submitData.fillingFlag = "normal" // 填报标记
      submitData.saveUserId = "zxtb"; // 用户id
      window.mlistener.selectRowData = submitData;
      window.open(config.ssfwptPage, '_blank');
    } else {
      //"ssfwpt_zxtb"
      // var form = $("#changeForm");
      // form.find("#changeForm_data").val(JSON.stringify(submitData));
      // form.submit();
      showLoading()
      var falg = "declare";
      $.ajax({
        type: "POST",
        // url: url + "/ssfwpt/declare/toPzzl",
        url: url + "/ssfwpt/declare/toPzzl",
        dataType: "json", // 请求方式为jsonp
        data: {
          data: JSON.stringify(submitData)
        },
        success: function (data) {
          hideLoading()
          console.log("taxInfo:", JSON.stringify(submitData))
          window.taxInfo = JSON.stringify(submitData);
          localStorage.setItem("data", JSON.stringify(submitData));
          if (data.url == "edit.jsp") {
            window.open(config.webUrl + "declare/edit.html?falg=" + falg + '&params=' + encodeURI(JSON.stringify(submitData)));
          } else if (data.url == "yearReport.jsp") {
            window.open(config.webUrl + "declare/yearReport.html?falg=" + falg + '&params=' + encodeURI(JSON.stringify(submitData)));
          } else if (data.url == "yearReportGLB.jsp") {
            window.open(config.webUrl + "declare/yearReportGLB.html?falg=" + falg + '&params=' + encodeURI(JSON.stringify(submitData)));
          } else {
            //因为后台不知道返回路径是什么样的就直接改成了else data.url == "error.jsp"
            window.open(config.webUrl + "error/index.html?falg=" + falg + '&params=' + encodeURI(JSON.stringify(submitData)));
          }
        },
        error: function (xhr) {
          //jsonp 方式此方法不被触发
          if (data.returnMessage == undefined) {
            if (data.returnMessage == undefined) {
              alertWarning(data.errmsg);
            } else {
              alertWarning("程序错误，请联系管理员！");
            }
          } else {
            alertWarning(data.returnMessage);
          }
          hideLoading()
          console.log("=======error======================")
        }
      })

      closeModal();
    }
  }
  /**
   * 重置调用方法
   * @param {} params
   */
  $("#reset,#reset1").on("click", refresh);
  $("#goRecord").click(function () {
    //TODO 调用备案接口
  });
  // 格式化后台返回的时间
  if (companyInfo.config.return) {
    $("#getInputValue").val(tool.formatDate(companyInfo.sbsq));
    nowdate = companyInfo.sbsq;
    drawGrid(companyInfo);
  }
  //页面出现滚动条，监听滚动条变化将高赋值给模态框
  window.onscroll = function () {
    $("#myModal").css("top", $(document).scrollTop() + 235);
  }
  return {
    changeDate: changeDate,
    reset: reset,
    declarationMethod: declarationMethod,
    closeModal: closeModal
  }
}
